#include "descriptor/descriptor.h"
#define ARRAYSIZE(array) (sizeof(array)/sizeof(*(array)))
#define FRAMES 100
#define DEGTORAD 0.0174532925f


int main(void) {

	ITEM blu,bianco,nero,naso,pupille,pelle,giallo,rosso,ambiente,oro,acqua,diamante_azzurro,diamante_rosso,diamante_bianco,diamante_viola,diamante_blu,diamante_arancione,diamante_verde;
	ITEM manoDestra,manoSinistra,sonic,palma,palme[10],cartello,chaosEmeralds[8],rings[50],ring_gigante,arcoMorte,mondo,surf_temp;
	ITEM scene;
	int i,numero_rings,numero_palme,numero_chaosEmeralds;
	char nome_item[20];

	set_background(0.676,0.861,0.953,TRUE);
	set_ambient_light(1,1,1,0.7);
	create_point_light(73.118,-0.466,82.573,1,1,1,4,300, "sole");
	//create_point_light(73.118,-0.466,82.573,1,1,1,10,150, "Sole2");


	//Definizione attributi

	//Attributo da usare per i piano che creano i lati e il cielo e la terra della scena
	ambiente = create_attribute("ambiente");
	set_color(ambiente,1.0,1.0,1.0,1.0,0.0);

	//oro
	oro = create_attribute("oro");
	set_color(oro,213.0/255.0,166.0/255.0,41.0/255.0,0.1,0.6);
	set_reflectivity(oro,0.5,50);
	set_transparency(oro,0.0,0.0,1,0.47);

	// acqua
	acqua = create_attribute("acqua");
	set_color(acqua,0.0/255.0,0.0/255.0,0.0/255.0,0.1,0.6);
	set_reflectivity(acqua,0.6,10);
	set_transparency(acqua,0.5,0.3,1,1.57);
	
	// diamanti
        diamante_azzurro = create_attribute("diamante_azzurro");
	set_color(diamante_azzurro,0.0/255.0,200.0/255.0,255.0/255.0,0.2,0.8);
	set_reflectivity(diamante_azzurro,0.4,5);
	set_transparency(diamante_azzurro,0.8,0.6,2,2.42);

	diamante_rosso = create_attribute("diamante_rosso");
	set_color(diamante_rosso,255.0/255.0,0.0/255.0,0.0/255.0,0.2,0.8);
	set_reflectivity(diamante_rosso,0.4,5);
	set_transparency(diamante_rosso,0.8,0.6,2,2.42);

	diamante_bianco = create_attribute("diamante_bianco");
	set_color(diamante_bianco,255.0/255.0,255.0/255.0,255.0/255.0,0.2,0.8);
	set_reflectivity(diamante_bianco,0.4,5);
	set_transparency(diamante_bianco,0.8,0.6,2,2.42);

	diamante_viola = create_attribute("diamante_viola");
	set_color(diamante_viola,220.0/255.0,0.0/255.0,255.0/255.0,0.2,0.8);
	set_reflectivity(diamante_viola,0.4,5);
	set_transparency(diamante_viola,0.8,0.6,2,2.42);

	diamante_blu = create_attribute("diamante_blu");
	set_color(diamante_blu,0.0/255.0,0.0/255.0,255.0/255.0,0.2,0.8);
	set_reflectivity(diamante_blu,0.4,5);
	set_transparency(diamante_blu,0.8,0.6,2,2.42);

	diamante_arancione = create_attribute("diamante_arancione");
	set_color(diamante_arancione,255.0/255.0,150.0/255.0,0.0/255.0,0.2,0.8);
	set_reflectivity(diamante_arancione,0.4,5);
	set_transparency(diamante_arancione,0.8,0.6,2,2.42);

	diamante_verde = create_attribute("diamante_verde");
	set_color(diamante_verde,0.0/255.0,220.0/255.0,0.0/255.0,0.2,0.8);
	set_reflectivity(diamante_verde,0.4,5);
	set_transparency(diamante_verde,0.8,0.6,2,2.42);


	//Attributi per sonic
	blu = create_attribute("blu");
	set_color(blu,0,0,180.0/255.0,0.5,0.5);

	bianco = create_attribute("bianco");
	set_color(bianco,1,1,1,0.2,0.5);
	set_reflectivity(bianco,0.05,5);

	nero = create_attribute("nero");
	set_color(nero,0,0,0,0.5,0.5);

	naso = create_attribute("naso");
	set_color(naso,0,0,0,0.5,0.5);
	set_reflectivity(naso,0.08,5);

	pupille = create_attribute("pupille");
	set_color(pupille,0,10.0/255.0,0,0.5,0.5);
	set_reflectivity(pupille,0.2,5);

	giallo = create_attribute("giallo");
	set_color(giallo,0,1,0,0.5,0.5);

	pelle = create_attribute("pelle");
	set_color(pelle,240.0/255.0,200.0/255.0,120.0/255.0,0.5,0.5);
	
	rosso = create_attribute("rosso");
	set_color(rosso,200.0/255.0,0,0,0.3,0.5);
	set_reflectivity(rosso,0.15,5);


	// Carica le pareti del mondo
	{
	surf_temp = read_nurbs("./pianoTerraBucato.dbe");
	set_translate(surf_temp,0,0,0.9);
	//set_translate(surf_temp,0,0,-1.9);
	set_domain_texture(surf_temp, ambiente,"../Textures/f0006.hr",0,1,0,1,TRUE,1.0,0.2);
	//set_attribute(surf_temp,blu);
	mondo = create_list(surf_temp, "mondo");

	surf_temp = read_nurbs("./pianoSottacqua.db");
	set_translate(surf_temp,0,0,0.9);
	//set_z_rotate(surf_temp,180,1);
	//set_translate(surf_temp,-0.01,0,-0.01);
	set_domain_texture(surf_temp, ambiente,"../Textures/limestone.hr",0.0,0.3,0.0,0.3,TRUE,0.5,0.5);
	//set_attribute(surf_temp,rosso);
	mondo = insert_in_list(mondo, surf_temp);


	surf_temp = read_nurbs("./pianoAcqua.db");
	set_scale(surf_temp,1.5,1.3,1);
	set_translate(surf_temp,-0.1,0.1,0.93);
	//set_z_rotate(surf_temp,180,1);
	//set_translate(surf_temp,-0.01,0,-0.01);
	//set_domain_texture(surf_temp, ambiente,"../Textures/leaf1.hr",0,1,0,1,TRUE,0.5,0.5);
	set_attribute(surf_temp,acqua);
	mondo = insert_in_list(mondo, surf_temp);
		
	surf_temp = read_nurbs("./pianoAlto.db");
	//set_z_rotate(surf_temp,180,1);
	//set_translate(surf_temp,-0.01,0,-0.01);
	set_domain_texture(surf_temp, ambiente,"../Textures/f0005.hr",0,1,0,1,TRUE,1.1,0.0);
	//set_attribute(surf_temp,ambiente);
	mondo = insert_in_list(mondo, surf_temp);
	
	surf_temp = read_nurbs("./pianoDestro.db");
	//set_x_rotate(surf_temp,90,1);
	set_domain_texture(surf_temp, ambiente,"../Textures/f0001.hr",0,1,0,1,TRUE,1.1,0.0);
	//set_attribute(surf_temp,rosso);
	mondo = insert_in_list(mondo, surf_temp);
	
	surf_temp = read_nurbs("./pianoSinistro.db");
	//set_y_rotate(surf_temp,-10,1);
	//set_translate(surf_temp,sin(45*DEGTORAD),0,sin(45*DEGTORAD));
	set_domain_texture(surf_temp, ambiente,"../Textures/f0003.hr",0,1,0,1,TRUE,1.1,0.0);
	//set_attribute(surf_temp,rosso);
	mondo = insert_in_list(mondo, surf_temp);
	
	surf_temp = read_nurbs("./pianoFrontale.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/f0002.hr",0,1,0,1,TRUE,1.1,0.0);
	//set_attribute(surf_temp,giallo);
	//mondo = insert_in_list(mondo, surf_temp);
	
	surf_temp = read_nurbs("./pianoDietro.db");
	//set_z_rotate(surf_temp,45,1);
	//set_scale_abs(surf_temp,2,2,2);
	set_domain_texture(surf_temp, ambiente,"../Textures/f0004.hr",0,1,0,1,TRUE,1.1,0.0);
	//set_attribute(surf_temp,giallo);
	mondo = insert_in_list(mondo, surf_temp);

//set_translate(mondo,0,-0.5,-1);
//set_translate(mondo,0,0,-2);
	set_scale(mondo,100,100,100);
	set_translate(mondo,0,0,7.39);
	}


	// Carica Sonic
	{
	surf_temp = read_nurbs("./AculeoAlto4.db");
	//set_domain_texture(temp, verde,"../Textures/cactus.hr",0,1,0,1,TRUE,0.5,0.7);
	set_attribute(surf_temp,blu);
	sonic = create_list(surf_temp, "sonic");
	
	surf_temp = read_nurbs("./AculeoAltoDestro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./AculeoAltoSinistro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./AculeoBassoDestro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./AculeoAltoDestro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./AculeoBassoSinistro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./AculeoMedio4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./AculeoMedioDestro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./AculeoMedioSinistro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./braccioDestro4.db");
	set_attribute(surf_temp,pelle);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./braccioSinistro4.db");
	set_attribute(surf_temp,pelle);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./Busto4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./calzinoDestro4.db");
	set_attribute(surf_temp,bianco);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./calzinoSinistro4.db");
	set_attribute(surf_temp,bianco);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./coda4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./copriOcchioDestro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./copriOcchioSinistro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./copriOrecchioDestro4.db");
	set_attribute(surf_temp,pelle);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./copriOrecchioSinistro4.db");
	set_attribute(surf_temp,pelle);
	sonic = insert_in_list(sonic, surf_temp);
	
	// mano destra
	surf_temp = read_nurbs("./palmoDestro4.db");
	manoDestra = create_list(surf_temp, "manoDestra");

	surf_temp = read_nurbs("./ditoAnulareDestro4.db");
	manoDestra = insert_in_list(manoDestra, surf_temp);
	
	surf_temp = read_nurbs("./ditoIndiceDestro4.db");
	manoDestra = insert_in_list(manoDestra, surf_temp);
	
	surf_temp = read_nurbs("./ditoMedioDestro4.db");
	manoDestra = insert_in_list(manoDestra, surf_temp);
	
	surf_temp = read_nurbs("./ditoMignoloDestro4.db");
	manoDestra = insert_in_list(manoDestra, surf_temp);
		
	surf_temp = read_nurbs("./ditoPolliceDestro4.db");
	manoDestra = insert_in_list(manoDestra, surf_temp);

	set_attribute(manoDestra,bianco);
	sonic = insert_in_list(sonic, manoDestra);

	// mano sinistra
	surf_temp = read_nurbs("./palmoSinistro4.db");
	manoSinistra = create_list(surf_temp, "manoSinistra");

	surf_temp = read_nurbs("./ditoAnulareSinistro4.db");
	manoSinistra = insert_in_list(manoSinistra, surf_temp);
	
	surf_temp = read_nurbs("./ditoIndiceSinistro4.db");
	manoSinistra = insert_in_list(manoSinistra, surf_temp);
	
	surf_temp = read_nurbs("./ditoMedioSinistro4.db");
	manoSinistra = insert_in_list(manoSinistra, surf_temp);
	
	surf_temp = read_nurbs("./ditoMignoloSinistro4.db");
	manoSinistra = insert_in_list(manoSinistra, surf_temp);
	
	surf_temp = read_nurbs("./ditoPolliceSinistro4.db");
	manoSinistra = insert_in_list(manoSinistra, surf_temp);
	
	set_attribute(manoSinistra,bianco);
	sonic = insert_in_list(sonic, manoSinistra);


	surf_temp = read_nurbs("./gambaDestra4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./gambaSinistra4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./laccioDestro4.db");
	set_attribute(surf_temp,bianco);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./laccioSinistro4.db");
	set_attribute(surf_temp,bianco);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./muso4.db");
	set_attribute(surf_temp,pelle);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./naso4.db");
	set_attribute(surf_temp,naso);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./occhi4.db");
	set_attribute(surf_temp,bianco);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./occhioDestro4.db");
	set_attribute(surf_temp,pupille);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./occhioSinistro4.db");
	set_attribute(surf_temp,pupille);
	sonic = insert_in_list(sonic, surf_temp);

	surf_temp = read_nurbs("./OrecchioDestro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./OrecchioSinistro4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./pancia4.db");
	set_attribute(surf_temp,pelle);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./scarpaDestra4.db");
	set_attribute(surf_temp,rosso);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./scarpaSinistra4.db");
	set_attribute(surf_temp,rosso);
	sonic = insert_in_list(sonic, surf_temp);
	
	surf_temp = read_nurbs("./testa4.db");
	set_attribute(surf_temp,blu);
	sonic = insert_in_list(sonic, surf_temp);

	// set_x_rotate(manoSinistra,90,1);
	set_translate(sonic,0.0,2.0,0.0);
	}


	// Carica l'arco della morte
	{
	arcoMorte = read_nurbs("./arcoMorte.db");
	set_domain_texture(arcoMorte, ambiente,"../Textures/pietra.hr",0.0,0.3,0.0,0.3,TRUE,0.5,0.5);
	set_scale(arcoMorte,30,30,30);
	set_translate(arcoMorte,-50.0,-50,-2.1);
	}
//

	// Carica gli anelli
	{

	// quest'anello non viene visualizzato, è usato solo per crearne le copie
	rings[0] = read_nurbs("./ring.db");
	set_attribute(rings[0],oro);
	set_y_rotate(rings[0],90,1);
	set_z_rotate(rings[0],20.0,1);
	set_scale(rings[0],6,6,6);
	set_translate(rings[0],-30.0,-40.0,0.0);
	

	// anelli intorno all'arco della morte
	numero_rings = 1;
	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_domain_texture(arcoMorte, ambiente,"../Textures/pietra.hr",0.0,0.3,0.0,0.3,TRUE,0.5,0.5);
	set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-18.0,-1.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-10.0,-0.7);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-6.5,1.3);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-4.0,4.5);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-3.0,9.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-3.7,13.5);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.0,-5.9,17.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.5,-9.2,18.9);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-20.9,-13.2,19.7);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-21.9,-17.5,19.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-22.5,-21.0,17.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-23.8,-24.0,13.7);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-24.8,-25.1,9.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-26.0,-23.0,4.0);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-26.0,-19.0,0.5);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],-27.0,-13.0,-1.0);
	numero_rings++;

	// anelli intorno a Sonic
	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],28.0,41.5,-1.5);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],32.0,41.5,-1.5);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],30.0,40.0,-1.5);
	numero_rings++;

	sprintf(nome_item,"ring_%d",numero_rings);
	rings[numero_rings] = create_copy(rings[0], nome_item);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(rings[numero_rings],30.0,43.0,-1.5);
	numero_rings++;
	
	// anello gigante
	ring_gigante = read_nurbs("./ring_gigante.db");
	set_attribute(ring_gigante,oro);
	set_y_rotate(ring_gigante,90,1);
	set_z_rotate(ring_gigante,45.0,1);
	set_scale(ring_gigante,6,6,6);
	set_translate(ring_gigante,-1.0,-1.0,0.8);
	}

	// carica le palme
	{

	// palma temporanea che verrà usata per crearne le copie
	surf_temp = read_nurbs("./tronco.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/wood-texture3.hr",0,1.0,0,1.0,TRUE,0.5,0.5);
	palma = create_list(surf_temp, "palma");

	surf_temp = read_nurbs("./foglia1.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);

	surf_temp = read_nurbs("./foglia2.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);

	surf_temp = read_nurbs("./foglia3.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);

	surf_temp = read_nurbs("./foglia4.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);

	surf_temp = read_nurbs("./foglia5.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);

	surf_temp = read_nurbs("./foglia6.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);

	surf_temp = read_nurbs("./foglia7.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);

	surf_temp = read_nurbs("./foglia8.db");
	set_domain_texture(surf_temp, ambiente,"../Textures/leaf3.hr",0,1,0,1,TRUE,0.3,0.3);
	palma = insert_in_list(palma,surf_temp);
	
	//set_z_rotate(cartello,45.0,1);
	set_scale(palma,50,50,50);
	set_translate(palma,0.0,0.0,21.5);

	numero_palme = 0;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],0.0,12.0,-5.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
		set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],-20.0,-20.0,-3.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],-30.0,-60.0,0.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],-30.0,60.0,-4.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],30.0,20.0,-2.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],60.0,30.0,0.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],80.0,0.0,-5.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],90.0,-30.0,-3.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],50.0,-52.0,-2.0);
	numero_palme++;

	sprintf(nome_item,"palma_%d",numero_palme+1);
	palme[numero_palme] = create_copy(palma, nome_item);
	set_z_rotate(palme[numero_palme],(int)(numero_palme*50) % 360,1);
	//set_translate(rings[numero_rings],-20.0,-14.0,-1.0);
	set_translate(palme[numero_palme],25.0,-70.0,0.0);
	numero_palme++;
	}

	// carica il cartello
	{
	surf_temp = read_nurbs("./cartelloBastone.db");
	set_domain_texture(surf_temp, bianco,"../Textures/marmo.hr",0,1,0,1,TRUE,0.5,0.5);
	cartello = create_list(surf_temp, "cartello");

	surf_temp = read_nurbs("./cartelloFaccia1.db");
	set_domain_texture(surf_temp, bianco,"../Textures/cartelloFacciaSonic.hr",0,1,0,1,TRUE,0.5,0.5);
	cartello = insert_in_list(cartello,surf_temp);

	surf_temp = read_nurbs("./cartelloFaccia2.db");
	set_domain_texture(surf_temp, bianco,"../Textures/cartelloFacciaEggman.hr",0,1,0,1,TRUE,0.5,0.5);
	cartello = insert_in_list(cartello,surf_temp);

	surf_temp = read_nurbs("./cartelloContorno.dbe");
	set_domain_texture(surf_temp, bianco,"../Textures/marmo.hr",0,1,0,1,TRUE,0.5,0.5);
	cartello = insert_in_list(cartello,surf_temp);
	set_scale(cartello,2,2,2);
	set_z_rotate(cartello,230.0,1);
	set_translate(cartello,-10.0,7.0,1.0);
	}

	// carica gli smeraldi del chaos
	{
	chaosEmeralds[0] = read_nurbs("./chaosEmerald.db");
	//set_y_rotate(ring_gigante,90,1);
	//set_z_rotate(ring_gigante,45.0,1);
	set_scale(chaosEmeralds[0],5,5,5);
	set_translate(chaosEmeralds[0],0.0,0.0,-1.5);

	numero_chaosEmeralds = 1;
	sprintf(nome_item,"chaosEmerald_%d",numero_chaosEmeralds);
	chaosEmeralds[numero_chaosEmeralds] = create_copy(chaosEmeralds[0], nome_item);
	set_attribute(chaosEmeralds[numero_chaosEmeralds],diamante_azzurro);
	//set_domain_texture(arcoMorte, ambiente,"../Textures/pietra.hr",0.0,0.3,0.0,0.3,TRUE,0.5,0.5);
	//set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(chaosEmeralds[numero_chaosEmeralds],-1.9,4.3,0.0);
	numero_chaosEmeralds++;

	sprintf(nome_item,"chaosEmerald_%d",numero_chaosEmeralds);
	chaosEmeralds[numero_chaosEmeralds] = create_copy(chaosEmeralds[0], nome_item);
	set_attribute(chaosEmeralds[numero_chaosEmeralds],diamante_rosso);
	//set_domain_texture(arcoMorte, ambiente,"../Textures/pietra.hr",0.0,0.3,0.0,0.3,TRUE,0.5,0.5);
	//set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(chaosEmeralds[numero_chaosEmeralds],-3.2,3.3,0.0);
	numero_chaosEmeralds++;

	sprintf(nome_item,"chaosEmerald_%d",numero_chaosEmeralds);
	chaosEmeralds[numero_chaosEmeralds] = create_copy(chaosEmeralds[0], nome_item);
	set_attribute(chaosEmeralds[numero_chaosEmeralds],diamante_bianco);
	//set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(chaosEmeralds[numero_chaosEmeralds],-4.5,4.3,0.0);
	numero_chaosEmeralds++;

	sprintf(nome_item,"chaosEmerald_%d",numero_chaosEmeralds);
	chaosEmeralds[numero_chaosEmeralds] = create_copy(chaosEmeralds[0], nome_item);
	set_attribute(chaosEmeralds[numero_chaosEmeralds],diamante_viola);
	//set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(chaosEmeralds[numero_chaosEmeralds],-4.5,5.9,0.0);
	numero_chaosEmeralds++;

	sprintf(nome_item,"chaosEmerald_%d",numero_chaosEmeralds);
	chaosEmeralds[numero_chaosEmeralds] = create_copy(chaosEmeralds[0], nome_item);
	set_attribute(chaosEmeralds[numero_chaosEmeralds],diamante_blu);
	//set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(chaosEmeralds[numero_chaosEmeralds],-3.2,6.9,0.0);
	numero_chaosEmeralds++;

	sprintf(nome_item,"chaosEmerald_%d",numero_chaosEmeralds);
	chaosEmeralds[numero_chaosEmeralds] = create_copy(chaosEmeralds[0], nome_item);
	set_attribute(chaosEmeralds[numero_chaosEmeralds],diamante_arancione);
	//set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(chaosEmeralds[numero_chaosEmeralds],-1.9,5.9,0.0);
	numero_chaosEmeralds++;

	sprintf(nome_item,"chaosEmerald_%d",numero_chaosEmeralds);
	chaosEmeralds[numero_chaosEmeralds] = create_copy(chaosEmeralds[0], nome_item);
	set_attribute(chaosEmeralds[numero_chaosEmeralds],diamante_verde);
	//set_attribute(rings[numero_rings],oro);
	//set_z_rotate(rings[numero_rings],numero_rings*10.0/360.0,1);
	set_translate(chaosEmeralds[numero_chaosEmeralds],-3.2,5.1,0.0);
	numero_chaosEmeralds++;
	}
/*
  teapot_brown = create_copy(teapot_glass, "brown_teapot");
  set_z_rotate(teapot_brown,120,1);
  set_translate(teapot_brown,6,0,0);
  set_scale(teapot_brown,0.6,0.6,0.6);
  set_z_rotate(teapot_brown,120,1);*/

  //set_attribute(teapot_glass,glass);
// 	set_attribute(sonic,glass);
  //set_attribute(teapot_brown,brown);

  //cup1 = read_obj("cup.obj", "ceramic_cup");
  //set_scale(cup1,0.05,0.05,0.05);
  //set_attribute(cup1,ceramic);

  //cup2 = create_copy(cup1, "second_cup");
  //set_translate(cup1,2,0,0);
  //set_z_rotate(cup2,-120,1);
  //set_translate(cup2,2,0,0);

  //table = read_nurbs("table.db");
//    set_translate(table,20,20,0);
 // set_wood_texture(table,yellow,blu);
//    set_translate(table,-20,-20,0);

	scene = create_list(mondo, "scene");
	scene = insert_in_list(scene,sonic);
	scene = insert_in_list(scene,arcoMorte);
	for (i=1; i<numero_rings; i++)
		scene = insert_in_list(scene,rings[i]);
	for (i=0; i<numero_palme; i++)
		scene = insert_in_list(scene,palme[i]);
	for (i=1; i<numero_chaosEmeralds; i++)
		scene = insert_in_list(scene,chaosEmeralds[i]);
	scene = insert_in_list(scene,ring_gigante);
	//scene = insert_in_list(scene,palma);
	scene = insert_in_list(scene,cartello);
//scene = create_list(mondo, "scene");
//   scene = insert_in_list(scene,table);
//   scene = insert_in_list(scene,cup1);
//   scene = insert_in_list(scene,cup2);

	save_scene("sonic.md","scene_sonic",scene);
	return(0);
}
